﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	
	Private fx As JFX
	Private viewer As Form
	Private owlPage As String
	
	Public designNum As Int
	Dim imgPart As ImageView
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(viewform As Form)
	viewer = viewform
	viewer.SetFormStyle("UTILITY")
End Sub

' Call to open form and display part image
Public Sub showPart(DNum As Int, desc As String)
	designNum = DNum
	viewer.Title = desc
	If Not(viewer.Showing) Then viewer.Show
	imgPart = viewer.RootPane.GetNode(0)
	loadImage
End Sub

Private Sub loadImage
	getOwlPage("https://www.brickowl.com/search/catalog?query=" & designNum)
End Sub

' Get the BrickOwl page containing the part information
Private Sub getOwlPage(url As String)
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(url)
	Wait For(j) jobdone(j As HttpJob)
	If j.Success Then
		owlPage = j.GetString
		extractImage																' Extract the part image
	End If
End Sub

' Extract and display the part image from the BrickOwl page
Private Sub extractImage
	Dim term As String = $"src="[^"]*"$						' Regex search term
	owlPage = owlPage.Replace(Chr(10), "")				' Remove EOLs for matcher
	Dim m As Matcher = Regex.Matcher(term, owlPage)
	Dim item As String														' Matches returned by matcher
	Dim notFound As Boolean = True
	Do While (m.Find And notFound)
		item = m.Match.ToLowerCase
		' Next line filters out set numbers that match part numbers
		If item.Contains(designNum) And Not(item.Contains("set")) Then
			Dim j As HttpJob
			j.Initialize("", Me)
			j.Download(item.SubString(5))							' Trim URL from returned text
			Wait For(j) jobdone(j As HttpJob)
			If j.Success Then
				imgPart.SetImage(j.GetBitmap)						' Display image
			End If
			notFound = False													' Abandon any further searches
		End If
	Loop
End Sub
